import simple_chalk as chalk
from datetime import datetime
import colorama 

colorama.init()

blue = chalk.blue
red = chalk.red
green = chalk.green
yellow = chalk.yellow
white = chalk.white
cyan = chalk.cyan

class AsyncLogger():
    def __init__(self,logName="placeholder",color=cyan,timeColor=cyan,datetime=True,bracketColor=green):
        self.date = datetime
        self.color = color
        self.logNmae = logName
        self.logName = bracketColor("[")+color(logName)+bracketColor("]")
        self.timeColor = timeColor
        self.dateTime = ''
        self.bracketColor = bracketColor

    async def close(self):
        pass

    async def __aenter__(self):
        return self

    async def __aexit__(self, *args):
        await self.close()

    async def getTime(self):
        return(self.bracketColor("[")+self.timeColor(datetime.now().strftime('%H:%M:%S'))+self.bracketColor("]"))

    async def warning(self,message):
        if self.date:
            self.dateTime = await self.getTime()
        message = self.dateTime + self.logName + " " +  red(message)
        print(message)

    async def success(self,message):
        if self.date:
            self.dateTime = await self.getTime()
        message = self.dateTime + self.logName + " " + green(message)
        print(message)

    async def normal(self,message):
        if self.date:
            self.dateTime = await self.getTime()
        message = self.dateTime + self.logName + " " +  yellow(message)
        print(message)
        
    async def custom(self,message,textColor=white):
        if self.date:
            self.dateTime = await self.getTime()
        message = self.dateTime + self.logName + " " +  textColor(message)
        print(message)


class Logger():
    def __init__(self,logName="placeholder",color=cyan,timeColor=cyan,datetime=True,bracketColor=green):
        self.date = datetime
        self.color = color
        self.logNmae = logName
        self.logName = bracketColor("[")+color(logName)+bracketColor("]")
        self.timeColor = timeColor
        self.dateTime = ''
        self.bracketColor = bracketColor

    def getTime(self):
        return(self.bracketColor("[")+self.timeColor(datetime.now().strftime('%H:%M:%S'))+self.bracketColor("]"))

    def warning(self,message):
        if self.date:
            self.dateTime = self.getTime()
        message = self.dateTime + self.logName + " " +  red(message)
        print(message)

    def log(self,message):
        if self.date:
            self.dateTime = self.getTime()
        message = self.dateTime + self.logName + " " +  red(message)
        print(message)

    def success(self,message):
        if self.date:
            self.dateTime = self.getTime()
        message = self.dateTime + self.logName + " " + green(message)
        print(message)

    def normal(self,message):
        if self.date:
            self.dateTime = self.getTime()
        message = self.dateTime + self.logName + " " +  yellow(message)
        print(message)

    def custom(self,message,textColor=white):
        if self.date:
            self.dateTime = self.getTime()
        message = self.dateTime + self.logName + " " +  textColor(message)
        print(message)
